package dev.flyfish.framework.approval.domain;

import dev.flyfish.framework.annotations.EnumValue;
import dev.flyfish.framework.annotations.Order;
import dev.flyfish.framework.annotations.Property;
import dev.flyfish.framework.approval.enums.ApproveStatus;
import dev.flyfish.framework.domain.authorized.AuthorizedQo;
import dev.flyfish.framework.query.QueryDefinition;
import lombok.Getter;
import lombok.Setter;

/**
 * 带审批的查询实体
 *
 * @author wangyu
 */
@Getter
@Setter
public class ApprovalDomainQo<T extends ApprovalDomain> extends AuthorizedQo<T> {

    @Property("审批状态")
    @Order(50)
    @EnumValue(ApproveStatus.class)
    private String status;

    @Override
    public QueryDefinition queryBuilder() {
        return super.queryBuilder().mutate().and(T::getApproveStatus).eq(status);
    }
}
