package dev.flyfish.framework.query.support;

import dev.flyfish.framework.domain.base.Domain;

/**
 * 支持序列化的实体方法
 *
 * @param <T> 泛型，父类为实体
 */
@FunctionalInterface
public interface DomainFunction<T extends Domain> extends SFunction<T, Object> {

    /**
     * 快速获取名称
     *
     * @return 序列化后的名称
     */
    default String getName() {
        return EntityNameUtils.getName(this);
    }
}
