package dev.flyfish.framework.domain.authorized.advanced;

import dev.flyfish.framework.annotations.Order;
import dev.flyfish.framework.annotations.Property;
import dev.flyfish.framework.domain.authorized.AuthorizedDomain;
import dev.flyfish.framework.domain.po.User;
import lombok.Getter;
import lombok.Setter;
import org.springframework.data.annotation.Reference;

import java.util.List;

/**
 * 具有特例拥有权限的实体
 *
 * @author wangyu
 */
@Getter
@Setter
public abstract class OwnedAuthorizedDomain extends AuthorizedDomain {

    // 关联账号
    @Property("关联账号")
    @Order(Integer.MAX_VALUE)
    @Reference(User.class)
    private List<User> owners;

}
