package dev.flyfish.framework.dict.annotations;

import dev.flyfish.framework.configuration.redis.EnableReactiveRedis;
import dev.flyfish.framework.dict.config.DictionaryConfig;
import org.springframework.context.annotation.Import;

import java.lang.annotation.*;

/**
 * 开启字典处理逻辑
 *
 * @author wangyu
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.TYPE)
@Documented
@Import(DictionaryConfig.class)
@EnableReactiveRedis
public @interface EnableDictProcess {

    /**
     * 扫描基本路径
     *
     * @return 结果
     */
    String[] basePackages() default "dev.flyfish.framework";
}
