package dev.flyfish.framework.form;

import dev.flyfish.framework.bean.ObjectMap;
import dev.flyfish.framework.configuration.boot.FlyfishApplication;
import dev.flyfish.framework.form.domain.OnlineForm;
import dev.flyfish.framework.form.repository.OnlineFormRepository;
import dev.flyfish.framework.r2dbc.config.R2dbcDataConfig;
import dev.flyfish.framework.utils.JacksonUtil;
import jakarta.annotation.Resource;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.context.annotation.Import;
import org.springframework.test.context.junit.jupiter.SpringExtension;

import java.util.Arrays;

@ExtendWith(SpringExtension.class)
@SpringBootTest(classes = FlyfishFormTest.class)
@FlyfishApplication(scanBasePackages = "dev.flyfish.framework")
@Import(R2dbcDataConfig.class)
@Slf4j
public class FlyfishFormTest {

    @Resource
    private OnlineFormRepository onlineFormRepository;

    @Test
    public void test() {
        OnlineForm form = new OnlineForm();
        form.setCode("form");
        form.setName("测试表单");
        form.setDescription("表单描述");
        form.setForm(Arrays.asList(
                new OnlineForm.FormItem()
        ));
        form.setLayout(new ObjectMap());
        onlineFormRepository.insert(form)
                .doOnNext(this::log)
                .block();
    }

    private void log(Object data) {
        log.info(JacksonUtil.toPrettyJson(data));
    }
}
