package dev.flyfish.framework.configuration.resolver;

import org.springframework.core.MethodParameter;
import org.springframework.web.reactive.BindingContext;
import org.springframework.web.server.ServerWebExchange;
import reactor.core.publisher.Mono;

public interface ParameterFilter<T> {

    /**
     * 从已有的拦截器解析数据
     *
     * @param parameter      方法参数
     * @param bindingContext 上下文
     * @param exchange       web数据
     * @return 结果
     */
    T filter(MethodParameter parameter, BindingContext bindingContext, ServerWebExchange exchange);

    default Mono<T> filterMono(MethodParameter parameter, BindingContext bindingContext, ServerWebExchange exchange) {
        return Mono.empty();
    }
}
